import router from './router';
import store from './store';
import { Message } from 'element-ui';
import NProgress from 'nprogress';
import 'nprogress/nprogress.css';
import { getToken, removeToken } from '@/utils/auth';
import { isRelogin } from '@/utils/request';
import { getResdirectAppUrl, parseSSoToken, ssoConfig } from '@/utils/sso';

NProgress.configure({ showSpinner: false });

const whiteList = ['/login', '/register'];

router.beforeEach(async (to, from, next) => {
  NProgress.start();

  let token = getToken();

  if (to.query.token) {
    removeToken();
    token = '';
  }

  if (!store.getters.ssoConfigInfo) {
    await store.dispatch('sso/getSSOConfigInfo');
  }

  if (token) {
    to.meta.title && store.dispatch('settings/setTitle', to.meta.title);
    /* has token*/
    if (to.path === '/login') {
      next({ path: '/' });
      NProgress.done();
    } else {
      if (store.getters.roles.length === 0) {
        // 判断当前用户是否已拉取完user_info信息
        store
          .dispatch('GetInfo')
          .then(() => {
            isRelogin.show = false;
            store.dispatch('GenerateRoutes').then((accessRoutes) => {
              // 根据roles权限生成可访问的路由表
              router.addRoutes(accessRoutes); // 动态添加可访问路由表
              next({ ...to, replace: true }); // hack方法 确保addRoutes已完成
            });
          })
          .catch((err) => {
            store.dispatch('LogOut').then(() => {
              Message.error(err);
              next({ path: '/' });
            });
          });
      } else {
        if (to.query.token) {
          next(to.path);
        } else {
          next();
        }
      }
    }
  } else {
    const result = await parseSSoToken(store, next, to);
    // 没有token
    if (result) {
    } else {
      if (
        whiteList.findIndex((item) => item.indexOf(to.path) > -1) !== -1 &&
        !ssoConfig.ssoEnabled &&
        to.path !== '/'
      ) {
        // 在免登录白名单，直接进入
        next();
      } else {
        // next(`/login?redirect=${to.fullPath}`); // 否则全部重定向到登录页
        getResdirectAppUrl();
        NProgress.done();
      }
    }
  }
});

router.afterEach(() => {
  NProgress.done();
});
